/*****************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2007 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://www.udf.adhoc-data.de> eMail <udf@adhoc-data.de>
 *  
 * File Name:	const_functions.c
 * Description: this module contains UDFs of technical constants
 * for exported functions list see const_functions.h
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*****************************************************************************/

#include <math.h>
#include "const_functions.h"

// mathematical constants
// pi
double pi ()
{
   return M_PI;
}

// e Euler
double euler ()
{
  return M_E;
}

// physical constants
// c Lichtgeschwindigkeit [m/s]
int c ()
{
  int result = 299792458;
  return result;
}

// g Erdbeschleunigung [m/s^2]
double g ()
{
  double result = 9.80665;
  return result;
}

// K absoluter Nullpunkt = 0Grad Kelvin
double k ()
{
  double result = -273.15;
  return result;
}

