/*****************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2007 adhoc dataservice GmbH
 * Christoph Theuring / Peter Mandrella / Georg Horn
 * <http://www.udf.adhoc-data.de> eMail <udf@adhoc-data.de>
 *
 * File Name:	conv_functions.h
 * Description: This header contains the prototype definitions
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*****************************************************************************/
 
double * in2m (double *);
double * ft2m (double *);
double * yd2m (double *);
double * mile2km (double *);
double * sm2km (double *);
double * fm2m (double *);
double * p2mm (double *);
double * m2in (double *);
double * m2ft (double *);
double * m2yd (double *);
double * km2mile (double *);
double * km2sm (double *);
double * m2fm (double *);
double * mm2p (double *);
double * ar2sqm (double *);
double * ha2sqm (double *);
double * morgen2sqm (double *);
double * sqft2sqm (double *);
double * ac2sqm (double *);
double * sqyd2sqm (double *);
double * sqm2ar (double *);
double * sqm2ha (double *);
double * sqm2morgen (double *);
double * sqm2sqft (double *);
double * sqm2ac (double *);
double * sqm2sqyd (double *);
double * bbl2l (double *);
double * gbfloz2ml (double *);
double * usfloz2ml (double *);
double * gbpt2l (double *);
double * uspt2l (double *);
double * gbqt2l (double *);
double * usqt2l (double *);
double * gbgal2l (double *);
double * usgal2l (double *);
double * rt2cbm (double *);
double * l2bbl (double *);
double * ml2gbfloz (double *);
double * ml2usfloz (double *);
double * l2gbpt (double *);
double * l2uspt (double *);
double * l2gbqt (double *);
double * l2usqt (double *);
double * l2gbgal (double *);
double * l2usgal (double *);
double * cbm2rt (double *);
double * ct2g (double *);
double * oz2g (double *);
double * oztr2g (double *);
double * lb2kg (double *);
double * g2ct (double *);
double * g2oz (double *);
double * g2oztr (double *);
double * kg2lb (double *);
double * g2t (double *);
double * bar2torr (double *);
double * bar2pa (double *);
double * psi2pa (double *);
double * torr2pa (double *);
double * cal2j (double *);
double * ps2kw (double *);
double * bhp2kw (double *);
double * t2g (double *);
double * torr2bar (double *);
double * pa2bar (double *);
double * pa2psi (double *);
double * pa2torr (double *);
double * j2cal (double *);
double * kw2ps (double *);
double * kw2bhp (double *);
double * c2f (double *);
double * f2c (double *);
int * roman2arabic(char *);
char * arabic2roman (int *);
int * convertfrom33 (char *);
char * convertto33 (int *);
int * convertfrombase (char *, int *, char *);
char * converttobase (int *, int *, char *);
char * inttohex (int *, int *);
int * hextoint (char *);
double *degtorad (double *);
double * radtodeg (double *);
